@echo off
@rem	version: v03
@rem	Note : many code pieces are scavenged in the internet; in most cases I don't even remember where... so thanks to the original programmers...
@rem	the string/character replacement script JREPL.bat needed here (created by Dave Benham) is a Swiss-Army-Pocket-Knife of string manipulation;
qrem	can be downloaded here: https://www.dostips.com/forum/viewtopic.php?f=3&t=6044&sid=d56e1fd78c9ea31839c82d26887da131
@rem	rename it to _JREPL.BAT and put it in the same directory as _Serie.bat
@rem	Note : !!NO WARRANTIES!! - the WMC database could be completely destroyed !!
@rem	Note : this file creates a VBS-Script : _confirm.vbs
@rem	Use : create in paralel to "\output"-folder an "\recreq"-folder and copy "_Serie.bat" in that folder;
@rem	start cmd.exe as Ademin; cd into the directory of the .bat and run it; populate the created "_rec.ini" (in the second run the vbs will be created)
@rem	set "dr" manually to a path where the working files should be buffered; e.g. to a RAM-Drive (like "x:\"); if not entered, files remain in the working path (typically where _Serie.bat is located)
@rem	if a correction of the rec-time for the local time zone is needed (that is normally not needed), set "correct_UTC=1"
@rem	if you don't want ehome to be closed at the end, set "closeEhome" to "0"
@rem	if you don't want a log-file, set "log" to "0"
@rem	epg123.mxf will be analyzed for entries with a certain title; the lineup backup of Media Center will be anylized to identify which services/channels are available

setlocal enabledelayedexpansion
 set "dr=x:\"
 set "correct_UTC=0"
 set "log=1"
 set "closeEhome=1"

@rem	get deviation from UTC (in sec)
 if !correct_UTC! EQU 1 (for /f "tokens=2 delims==" %%b in ('wmic OS Get CurrentTimeZone /value ^| find "="') do (set /a "correct_UTC=%%b*60"))
@rem	generate creation time; is not needed for c2r but might be useful for other scenarios...
 for /f "tokens=1,2 delims==" %%b in ('wmic path Win32_LocalTime get /value ^| find "="') do (set "local_%%b=%%c")
 set "local_minute=0%local_minute%"
 set "local_minute=%local_minute:~-2%"
 set "local_day=0%local_day%"
 set "local_day=%local_day:~-2%"
 set "local_month=0%local_month%"
 set "local_month=%local_month:~-2%"
 set "ctime=%local_year%-%local_month%-%local_day%T%local_hour%:%local_minute%:00"

 rem	save codepage
 for /f "tokens=3 delims=:. " %%x in ('chcp') do set "_codepage=%%x"


 if not exist "_rec.ini" (call :ini & echo _rec.ini is empty ! & pause & goto :eof)

 if not exist "_confirm.vbs" (call :vbs)


@rem	find latest datadase backup with the latest mapped/merged channels
 set "Lineup=C:\ProgramData\Microsoft\eHome"
 for /f "delims=*" %%x in ('dir /a:d /o:n /b "!Lineup!\mcepg*"') do set "z=!Lineup!\%%x\backup\lineup\"
@rem	convert lineup file; this is the latest MC-Backup
 for /f "delims=*" %%i in ('dir /b/a-d/od/t:c "!z!"') do set "Lineup=!z!%%i"
 setlocal disabledelayedexpansion
 call _jrepl.bat "! \x22\x22 \x22" "_ \xA7_\xA7 \xA7" /t " " /xseq /UTF /f "%Lineup%|UTF-8|NB" /o "%dr%___lineup.mx|UTF-8|NB"
 endlocal
 >NUL chcp 65001 & >"!dr!_3_search.txt" set /p "=MergedChannel.*userBlockedState=§1§" <NUL & >NUL chcp !_codepage!
 for %%b in ("!dr!___lineup.mx") do findstr /g:!dr!_3_search.txt "%%b">!dr!_0_lineup.mx
 del !dr!___lineup.mx !dr!_3_search.txt >NUL

@rem	convert mxf file
 setlocal disabledelayedexpansion
 call _jrepl.bat "! \x22\x22 \x22" "_ \xA7_\xA7 \xA7" /t " " /xseq /UTF /f "..\output\epg123.mxf|UTF-8|NB" /o "%dr%_0_epg123.mx|UTF-8|NB"
 endlocal


@rem	create matrix of services/channels and mark them as actually used/unused (1/0) in the MC-EPG
 > "!dr!_1_servicemapping.txt" (for /f "tokens= 2,4,8 delims=§" %%b in ('findstr /brc:"  *<Service id" !dr!_0_epg123.mx') do (set "z=0" & (findstr /rc:"%%c" !dr!_0_lineup.mx >NUL && set "z=1") & (echo %%b%%c%%d!z!)))


@rem	extract service entries (broadcast events; only the first occurence is considered; this routine assumes that a new broadcast will get the next higher number, not a random higher number)
 set "time="
 set "offset="
 set "service="
 set "last_prg=0"

 echo Format : idserviceepg123_servicecallsignmappedtimeOffsetduration(sec)>"!dr!_2_service.txt"
 >>"!dr!_2_service.txt" (
  for /f "tokens=1-6 delims=§" %%b in ('findstr /brc:"  *<ScheduleEntr" !dr!_0_epg123.mx') do (
	echo "%%b" | findstr /c:"ScheduleEntries service=" >nul && (for /f "delims=*" %%h in ('findstr /c:"%%c" !dr!_1_servicemapping.txt') do (set "service=%%h")
	) || (
	  echo "%%d" | findstr /c:" startTime=" >nul && (
		set "time=%%e" & set "time=!time:-0=-!" & set "time=!time:T0=T!" & set "time=!time::0=:!"
		set "offset=%%g"
		if %%c gtr !last_prg! (set /a "last_prg=%%c" & echo %%c!service!!time!0%%g)
		) || (
		 if %%c gtr !last_prg! (
			echo %%c!service!!time!!offset!%%e
			set /a "last_prg=%%c"
			)
 		 set /a "offset+=%%e"
		)
	)
  )
 )


@rem     compile the actual data needed for the requested recordings; eliminate "done" recordings; create recording requests
 set "rectime="
 Set "serv="
 set "nr=10"
 if !log! EQU 1 (echo !ctime!>>"_Serie.log")
 for /f "skip=2 tokens=1-4 delims=	" %%b in (_rec.ini) do (
	rem creat episode number in a way that leading zeros are not disturbing
	for /f "tokens=1,2 delims=se#" %%f in ("%%d") do (
		for /f "tokens=* delims=0" %%h in ("%%f") do (if "%%h" == "" (set /a "s=0") else (set /a "s=%%h * 10000"))
		for /f "tokens=* delims=0" %%h in ("%%g") do (if "%%h" NEQ "" (set /a "s=!s!+%%h"))
		)
	rem	create an UTF-8 search file without BOM
	if %%e == x (>NUL chcp 65001 & >"!dr!_3_search.txt" set /p "=§ title=§%%b§" <NUL & >NUL chcp !_codepage!
		) else (>NUL chcp 65001 & >"!dr!_3_search.txt" set /p "=§ title=§%%b" <NUL & >NUL chcp !_codepage!)


	for %%g in ("!dr!_0_epg123.mx") do findstr /g:!dr!_3_search.txt "%%g">!dr!_4_hits.txt

	rem	create an UTF-8 search file without BOM for episodes of the title
	>NUL chcp 65001 & >"!dr!_3_search.txt" set /p "=%%b" <NUL
	call :done "" ""
	>NUL chcp !_codepage!

	call :episodes
	)


 for %%b in ("*_done_.txt") do (set "done=%%b" & set "done=!done:~0,-5!" & sort "%%b" /o "!done!.txt")
 del "*_done_.txt" >nul


 for %%b in ("!dr!*.c2r") do (
	start "" %%b
	timeout /T 5 /nobreak

	start "" "%~dp0_confirm.vbs"
	timeout /T 4 /nobreak
	)


 del "!dr!_?_*.*" >nul
 del "!dr!*.c2r" >nul
 if !closeEhome! EQU 1 (TASKKILL /F /IM ehshell.exe >Nul >2Nul)
 if !log! EQU 1 (echo .>>"_Serie.log")

exit /B



::---------------------------------------------------------------------------------------
:done
 if %1 EQU "" (
	for /f "tokens=*" %%e in (!dr!_3_search.txt) do (if exist "%%e_done.txt" (ren "%%e_done.txt" "%%e_done_.txt") else (if not exist "%%e_done_.txt" (>"%%e_done_.txt" set /p "=" <NUL)))
	) else (
	if %1=="find" (
		for /f "tokens=*" %%e in (!dr!_3_search.txt) do (findstr %2 "%%e_done_.txt" >nul 2>nul && set "done=1")
		) else (
		for /f "tokens=*" %%e in (!dr!_3_search.txt) do (echo %1>>%%e_done_.txt)
		)
 )

goto :eof


::---------------------------------------------------------------------------------------
:episodes
 for /f "tokens=2,4,10 delims=§" %%h in ('findstr /brc:"  *<Program id" !dr!_4_hits.txt') do (
	rem create episode number in a way that leading zeros are not disturbing
	for /f "tokens=1 delims= " %%k in ("%%j") do (
		set "episode=%%k"
		for /f "tokens=1,2 delims=se#" %%l in ("%%k") do (
			for /f "tokens=* delims=0" %%n in ("%%l") do (if "%%n" == "" (set /a "ss=0") else (set /a "ss=%%n * 10000"))
			for /f "tokens=* delims=0" %%n in ("%%m") do (if "%%n" NEQ "" (set /a "ss=!ss!+%%n"))
			)
		)
	set "done=1"

	rem	looking for exactly this episode
	if "%%c!s!" EQU "=!ss!" (set "done=0"
		) else (
		rem	looking for episode later than sXXeYY
		if "%%c" EQU ">" (if !ss! GTR !s! (set "done=0")
			) else (
			rem	looking for episode earlier than sXXeYY
			if "%%c" EQU "<" (if !ss! LSS !s! (set "done=0"))
			)
	)
	rem	checking whether this episode was already recorded
	if !done! EQU 0 (>NUL chcp 65001 & call :done "find" !episode! & >NUL chcp !_codepage!)
	if !done! EQU 0 (
		set "z=0"
		call :recdetails %%h
		rem	create click-to-record request if channel is mapped
		if "!z!" EQU "0" (
			call :c2r
			>NUL chcp 65001 & call :done !episode! "" & >NUL chcp !_codepage!
			set /a "nr=!nr!+1"
			)
		)
	)
 )

goto :eof


::---------------------------------------------------------------------------------------
:recdetails
	for /f "skip=%1 tokens=4-8 delims= " %%n in (!dr!_2_service.txt) do (
		@rem	quit if channel is not mapped
		if "%%o" EQU "0" (set "z=3" & goto :eof)
		for /F "tokens=1-6 delims=-:T" %%s in ("%%p") do (
			set "y=%%s" & set /a "m=%%t" & set /a "d=%%u" & set /a "h=%%v" & set /a "mi=%%w" & set /a "sc=%%x"
			)

	set /a "offset=%%q+!correct_UTC!"
	set /a "sc=!sc!+(!offset!%%60)"
	set /a "mi=!mi!+((!offset!/60)%%60)
	set /a "h=!h!+((!offset!/3600)%%24)
	set /a "d=!d!+(!offset!/86400)"
	if !sc! GTR 59 (set /a "sc=!sc!-60" & set /a "m=!mi!+1")
	if !mi! GTR 59 (set /a "h=!h!+(!mi!/60)" & set /a "mi=!mi!%%60")
	if !h! GTR 23 (set /a "d=!d!+(!h!/24)" & set /a "h=!h!%%24")

	@rem	does take into account leap years until 2100
	if !m! EQU 2 (
		set /a "leap=!y!%%4"
		if !leap! EQU 0 (set /a "leap=29") else (set /a "leap=28")
		if not !d! LEQ !leap! (set /a "m=3" & set /a "d=!d!-!leap!")
		)
	@rem	30-day-months
	echo !m!| findstr "4 6 9 11" >nul && (if !d! GTR 30 (set /a "d=!d!-30" & set /a "m=!m!+1"))
	@rem	31-day-months
	if !d! GTR 31 (set /a "d=!d!-31" & set /a "m=!m!+1" & if !m! GTR 12 (set /a "y=!y!+1" & set /a "m=1"))

	set "rectime=!y!-"
	if !m! LSS 10 (set "rectime=!rectime!0")
	set "rectime=!rectime!!m!-"
	if !d! LSS 10 (set "rectime=!rectime!0")
	set "rectime=!rectime!!d!T"
	if !h! LSS 10 (set "rectime=!rectime!0")
	set "rectime=!rectime!!h!:"
	if !mi! LSS 10 (set "rectime=!rectime!0")
	set "rectime=!rectime!!mi!:"
	if !sc! LSS 10 (set "rectime=!rectime!0")
	set "rectime=!rectime!!sc!Z"
	set "serv=%%n"
	goto :eof
	)

goto :eof


::---------------------------------------------------------------------------------------
:c2r
> "!dr!_!nr!_recreq.c2" (
echo ^<?xml version="1.0" encoding="utf-8" ?^>
echo ^<clickToRecord xmlns="urn:schemas-microsoft-com:ehome:clicktorecord"^>
echo ^<body^>
echo ^<programRecord^>
echo    ^<program^>
for /f "tokens=*" %%e in (!dr!_3_search.txt) do (echo        ^<key field="urn:schemas-microsoft-com:ehome:epg:program#title" match="contains"^>%%e^<^/key^>)
echo    ^<^/program^>
echo    ^<service^>
echo        ^<key field="urn:schemas-microsoft-com:ehome:epg:service#callsign" match="exact"^>!serv!^<^/key^>
echo    ^<^/service^>
echo    ^<airing^>
echo        ^<key field="urn:schemas-microsoft-com:ehome:epg:airing#starttime"^>!rectime!^<^/key^>
echo    ^<^/airing^>
echo ^<^/programRecord^>
echo ^<^/body^>
echo ^<^/clickToRecord^>
)

 rem	change codepage
 >NUL chcp 65001
 rem	set byte order mark (BOM) for outfile
 >"!dr!_!nr!_recreq.c2r" set /p "=﻿" <NUL
 >>"!dr!_!nr!_recreq.c2r" type "!dr!_!nr!_recreq.c2"
 rem	restore console to original codepage
 >NUL chcp !_codepage!
 del !dr!_!nr!_recreq.c2 >nul

 if !log! EQU 1 (for /f "tokens=*" %%e in (!dr!_3_search.txt) do (echo %%e	!episode!	!serv!	!rectime!>>"_Serie.log"))

goto :eof


::---------------------------------------------------------------------------------------
:ini
> "_rec.in" (
echo rem	enter below these two lines episodes^/series which shall be recorded ^(a Series can apear more than one time^) in the format :
echo rem	titel starting with[tab]operator ^>,^<,^=[tab]season-episode 'sxxexx' or '#1234' e.g. s06e05 ^(optional: [tab]x ^(titel must exactly fit^)^); spaces in the title are allowed; other special characters might ^(not^) work
echo Fake Series	^>	s01e00	x
echo next Fake	^=	s07e11
)

 rem	change codepage
 >NUL chcp 65001
 rem	set byte order mark (BOM) for outfile
 >"_rec.ini" set /p "=﻿" <NUL
 >>"_rec.ini" type "_rec.in"
 rem	restore console to original codepage
 >NUL chcp !_codepage!
 del _rec.in >nul
goto :eof


::---------------------------------------------------------------------------------------
:vbs
> "_confirm.vbs" (
echo Set WshShell = WScript.CreateObject^("WScript.Shell"^)
echo WshShell.AppActivate "ehshell.exe"
echo WshShell.SendKeys "{ENTER}"
echo WScript.Quit^(0^)
)
goto :eof
